

$('.autoplay').slick({
    slidesToShow: 3,
    slidesToScroll: 1,
    autoplay: true,
    autoplaySpeed: 2000,
    arrows: false,
});

(function ($) {
    'use strict';

    // Select the progress bar element
    const progressBar = $('#progress-bar')[0];

    // Function to debounce scroll events
    function debounce(func, wait, immediate) {
        let timeout;
        return function() {
            const context = this, args = arguments;
            const later = function() {
                timeout = null;
                if (!immediate) func.apply(context, args);
            };
            const callNow = immediate && !timeout;
            clearTimeout(timeout);
            timeout = setTimeout(later, wait);
            if (callNow) func.apply(context, args);
        };
    }

    // Update progress bar height based on the scroll position
    function updateProgressBar() {
        const windowHeight = $(window).height();
        const documentHeight = $(document).height() - windowHeight;
        const scrollTop = $(window).scrollTop();
        const scrollPercentage = (scrollTop / documentHeight) * 100;

        // Update progress bar height based on the scroll position
        progressBar.style.height = scrollPercentage + '%';
    }

    // Debounced function to update progress bar on scroll
    const debouncedUpdateProgressBar = debounce(updateProgressBar, 10);

    // Add a scroll event listener to update the progress bar
    $(window).on('scroll', debouncedUpdateProgressBar);

})(jQuery);

(function ($) {
    'use strict';

    const sections = $(".jumper");
    const navLinks = $(".sidenav-link");

    function activateLink() {
      let index = sections.length - 1;

      while (index >= 0 && $(window).scrollTop() + 50 < $(sections[index]).offset().top) {
        index--;
      }

      navLinks.removeClass("active unactive");
      $(navLinks[index]).addClass("active").removeClass("unactive");
      navLinks.each(function(i) {
        if (i !== index) {
          $(this).addClass("unactive");
        }
      });
    }

    activateLink();
    $(window).on("scroll", activateLink);
})(jQuery);

document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('lottie-lightbulb');

  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});

document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('lottie-hammer-spanner');

  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});
document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('lottieBrick');

  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});


document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('lottie-heart');
  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});
document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('toolbox');
  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});

document.addEventListener("DOMContentLoaded", function() {
  const player = document.getElementById('lottie-microscope');
  if(player !== null) {
    const observer = new IntersectionObserver((entries) => {
        entries.forEach(entry => {
            if (entry.isIntersecting) {
                // Animation abspielen, wenn sichtbar
                player.play();
            } else {
                // Animation anhalten, wenn nicht mehr sichtbar
                player.stop();
            }
        });
    }, {
        threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
    });
    observer.observe(player);
  };
});

document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-globe');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-toolbox');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-star');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-computer');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-goggles');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-pipette');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-gear');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-partcollection');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-partners');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-notebook');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-survey');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-education');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

  document.addEventListener("DOMContentLoaded", function() {
    const player = document.getElementById('lottie-megaphone');

    if(player !== null) {
      const observer = new IntersectionObserver((entries) => {
          entries.forEach(entry => {
              if (entry.isIntersecting) {
                  // Animation abspielen, wenn sichtbar
                  player.play();
              } else {
                  // Animation anhalten, wenn nicht mehr sichtbar
                  player.stop();
              }
          });
      }, {
          threshold: 0.1 // Animation startet, wenn 10% sichtbar ist
      });
      observer.observe(player);
    };
  });

$(document).ready(function() {
  const $interBubble = $('.interactive');
  let curX = 0;
  let curY = 0;
  let tgX = 0;
  let tgY = 0;

  function move() {
    curX += (tgX - curX) / 20;
    curY += (tgY - curY) / 20;
    $interBubble.css('transform', `translate(${Math.round(curX)}px, ${Math.round(curY)}px)`);
    requestAnimationFrame(move);
  }

  $(window).on('mousemove', function(event) {
    tgX = event.clientX;
    tgY = event.clientY;
  });

  move();
});

$(document).ready(function () {
  // Ensure all dropdown content is hidden initially
  $('.dropdown-content').hide();

  $('.dropbtn').click(function (event) {
      event.preventDefault();
      event.stopPropagation(); // Stop the click from bubbling to the document

      var $dropdownContent = $(this).next('.dropdown-content');

      if ($dropdownContent.is(':visible')) {
          $dropdownContent.slideUp();
      } else {
          $('.dropdown-content').slideUp(); // Hide any other open dropdowns
          $dropdownContent.stop(true, true).slideDown(); // Stop ongoing animations before sliding down
      }
  });

  // Close the dropdown if clicking outside of it
  $(document).click(function (e) {
      if (!$(e.target).closest('.dropdown').length) {
          $('.dropdown-content').slideUp();
      }
  });
});

$(document).ready(function() {
  $(document).on('click', '.page-link', function(event) {
      event.preventDefault();

      window.location.href = $(this).attr('href');
  });

  if (window.location.pathname.includes('gallery')) {
      $('body').css({
          'background-color': '#841F44',
      });
      $('<style>body::before { content: none !important; background-image: none !important; }</style>').appendTo('head');
      $('footer').css({
          'background-color': '#841F44',
          'background': 'none',
      });
      $('footer p, footer h4').css({
          'color': '#fff',
      });
  }
  const pageNames = [
    'description',
    'engineering',
    'safety',
    'contribution',
    'model',
    'software',
    'experiments',
    'results',
    'notebook',
    'parts',
    'human-practices',
    'public-engagement',
    'education',
    'gallery',
    'team',
    'attributions',
    'sponsors',
    'application',
    'fred-fun',
    'awards'
  ];

  const currentPath = window.location.pathname;
  const header = $('.primaryheader');

  if (pageNames.some(page => currentPath.includes(page))) {
    $('body').addClass('Hero-visible');
    header.find('.nav-link').css('color', 'white');
  }
});


$(document).ready(function() {
    const $navbar = $('.navbar');
    const $hero = $('.Hero');

    function adjustHeroHeight() {
        const navbarHeight = $navbar.outerHeight();
        $hero.css('height', `calc(100vh - ${navbarHeight}px)`);
    }

    adjustHeroHeight();
    $(window).resize(adjustHeroHeight);
});

document.addEventListener("DOMContentLoaded", function() {
  function fetchAndLoadPDBprotein(proteinName, viewerId) {
    const pdbFilePath = `https://static.igem.wiki/teams/5237/${proteinName}.json`;

    fetch(pdbFilePath)
      .then(response => {
        if (!response.ok) {
          throw new Error('Network response was not ok');
        }
        return response.text();
      })
      .then(pdbData => {
        loadPDBFromDataprotein(pdbData, viewerId);
      })
      .catch(error => {
        console.error('There was a problem with the fetch operation:', error);
      });
  }

  function loadPDBFromDataprotein(pdbData, viewerId) {
    let viewerElement = document.getElementById(viewerId);

    if (viewerElement.viewer && typeof viewerElement.viewer.clear === "function") {
      viewerElement.viewer.clear();
    } else {
      viewerElement.viewer = $3Dmol.createViewer(viewerId, {
        backgroundColor: "white",
      });
    }

    viewerElement.viewer.addModel(pdbData, "pdb");
    viewerElement.viewer.setStyle({"chain": "A"},{"cartoon": {'colorscheme': {'prop': 'b', 'gradient': 'roygb', 'min': 0, 'max': 100,'opacity':1}}});
    viewerElement.viewer.setStyle({"chain": "B"},{"cartoon": {'colorscheme': {'prop': 'b', 'gradient': 'roygb', 'min': 0, 'max': 100,'opacity':1}}});
    viewerElement.viewer.setStyle({"chain": "O"}, {"cartoon": {'color': 'orange'}});
    viewerElement.viewer.setStyle({"chain": "L"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "K"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "M"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "N"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.zoomTo();
    viewerElement.viewer.render();
  }
  function fetchAndLoadPDBleucin(proteinName, viewerId) {
    const pdbFilePath = `https://static.igem.wiki/teams/5237/model/${proteinName}.json`;

    fetch(pdbFilePath)
      .then(response => {
        if (!response.ok) {
          throw new Error('Network response was not ok');
        }
        return response.text();
      })
      .then(pdbData => {
        loadPDBFromDataleucin(pdbData, viewerId);
      })
      .catch(error => {
        console.error('There was a problem with the fetch operation:', error);
      });
  }

  function loadPDBFromDataleucin(pdbData, viewerId) {
    let viewerElement = document.getElementById(viewerId);

    if (viewerElement.viewer && typeof viewerElement.viewer.clear === "function") {
      viewerElement.viewer.clear();
    } else {
      viewerElement.viewer = $3Dmol.createViewer(viewerId, {
        backgroundColor: "white",
      });
    }

    viewerElement.viewer.addModel(pdbData, "pdb");
    viewerElement.viewer.setStyle({"chain": "C"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "D"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "E"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "F"}, {"cartoon": {'color': 'grey'}});
    viewerElement.viewer.setStyle({"chain": "A"},{"cartoon": {'colorscheme': {'prop': 'b', 'gradient': 'roygb', 'min': 0, 'max': 100,'opacity':1}}});
    viewerElement.viewer.setStyle({"chain": "B"},{"cartoon": {'colorscheme': {'prop': 'b', 'gradient': 'roygb', 'min': 0, 'max': 100,'opacity':1}}});
    viewerElement.viewer.zoomTo();
    viewerElement.viewer.render();
  }

  if (document.querySelector('.viewer-wrapper')) {
    fetchAndLoadPDBprotein('protein', 'viewer1');
    fetchAndLoadPDBleucin('dual-tetr-sist', 'viewer2');
  }
});

document.addEventListener("DOMContentLoaded", function() {
  const button = document.getElementById("toggleButton");
  const body = document.body;

  button.addEventListener("click", () => {
      // Toggle between classes to hide even or odd canvas elements
      if (body.classList.contains("hide-even")) {
          body.classList.remove("hide-even");
          body.classList.add("hide-odd");
      } else {
          body.classList.remove("hide-odd");
          body.classList.add("hide-even");
      }
  });
});

$(document).ready(function () {
  var $section = $('.engineering-cycle-wrapper');
  var $visSection = $('#wetlab-section');
  $section.height($visSection.height());
});

function showSection(section) {
  $('#wetlab-section, #drylab-section, #hp-section').removeClass('active');
  $('#' + section + '-section').addClass('active');

  var $section = $('.engineering-cycle-wrapper');
  var $visSection = $('#' + section + '-section');
  $section.height($visSection.height());
}

// Experiment enlarger
document.addEventListener('DOMContentLoaded', function() {
  var collapseElements = document.querySelectorAll('.experiments-collapse-row');

  collapseElements.forEach(function(element) {
    element.addEventListener('hidden.bs.collapse', function () {
      var icon = element.querySelector(".col-12 > button > .protocol-icon-wrapper > .protocol-icon")

      icon.classList.remove('fa-minus');
      icon.classList.add('fa-plus');

    });

    element.addEventListener('shown.bs.collapse', function () {
      var icon = element.querySelector(".col-12 > button > .protocol-icon-wrapper > .protocol-icon")

      icon.classList.remove('fa-plus');
      icon.classList.add('fa-minus');
    });


  });
});


//Materials Nav Logic
$(document).ready(function() {
  $('.materials-header-element').click(function() {
      var clickedContent = $(this).attr('data-target');
      var targetPreview = $('#' + clickedContent);
      var targetContent = $('#' + clickedContent + '-content');
      var openPreview = $('.materials-header-preview.active');
      var openContent = $('.materials-content.active');
      var openElement = $('.materials-header-element.active');

      openPreview.removeClass('active');
      openContent.removeClass('active');
      openElement.removeClass('active');

      $(this).addClass('active');
      targetPreview.addClass('active');
      targetContent.addClass('active');

  });
});
//Notebook Nav Logic
$(document).ready(function() {
  $('.notebook .materials-nav-link').click(function() {
      var clickedContent = $(this).attr('data-target');

      var überContainer = $(this).closest('.materials-header-preview');

      var targetPDF = $('#' + clickedContent);
      var clickedContent = $('#' + clickedContent + '-content');

      var openLink = überContainer.find('.materials-nav-link.active');
      var openPDF = clickedContent.find('.notebook-pdf.active');

      openLink.removeClass('active');
      openPDF.removeClass('active');

      $(this).addClass('active');
      targetPDF.addClass('active');
  });
});

// Blobmenu
$(document).ready(function() {
  const $items = $('.blobmenu-item');
  const $border = $('.blobmenu-border');
  const $blob = $('.blob');
  const $boxes = $('.text-element .blob-content');

  $items.on('click', function() {
      $items.removeClass('active');
      $(this).addClass('active');

      const index = $(this).data('index');
      const offset = index * 25;

      $blob.css('left', offset + '%');

      $boxes.removeClass('active');
      $boxes.eq(index).addClass('active');
  });

  const $activeItem = $('.blobmenu-item.active');
  const initialIndex = $activeItem.data('index');
  const initialOffset = initialIndex * 25;
  $border.css('left', initialOffset + '%');

  $boxes.removeClass('active');
  $boxes.eq(initialIndex).addClass('active');
});


// Interview slick carousel


$('.single-item').slick({
  slidesToShow: 1,
  slidesToScroll: 1,
  dots: false,
  infinite: true,
  speed: 300,
  prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-chevron-left"></i></button>',
  nextArrow: '<button type="button" class="slick-next"><i class="fas fa-chevron-right"></i></button>',
});

$(document).ready(function() {
  // Use event delegation
  $(document).on("click", ".clickable", function() {
    var $contentBlock = $(".content-block");
    var $clickables = $contentBlock.find(".clickable");
    var index = $clickables.index(this);

    console.log(index);

    $("svg .clickable").removeClass("active");
    $(this).addClass("active");
    console.log("hello");

    $('.single-item').slick('slickGoTo', index);
  });
});

$('.single-item').on('afterChange', function(event, slick, currentSlide){
  if ($(window).width() > 572) {
    var $contentBlock = $(".content-block");
    var $clickables = $contentBlock.find(".clickable");

    $clickables.removeClass("active");
    var $activeClickable = $clickables.eq(currentSlide);
    $activeClickable.addClass("active");
    var jumperSpot = $activeClickable.find(".Kreis");

    // Center the active clickable group in the viewport
    var viewportHeight = $(window).height();
    var elementOffset = jumperSpot.offset().top;
    var elementHeight = jumperSpot.outerHeight();
    var scrollToPosition = elementOffset - (viewportHeight / 2) + (elementHeight / 2);

    $('html, body').animate({
      scrollTop: scrollToPosition
    }); // Adjust the speed as needed
  }
});

// Education Page
document.addEventListener('DOMContentLoaded', function() {
  const containerElements = document.querySelectorAll('.container-content');
  const clickableGroups = document.querySelectorAll('.clickable-group-edu-nav');
  const iconEduNav = document.querySelectorAll('.icon-edu-nav');


  clickableGroups.forEach((clickable, index) => {
    clickable.addEventListener('click', function() {

      clickableGroups.forEach(container => {
        container.classList.remove('active');
      });
      clickable.classList.add('active');

      containerElements.forEach(container => {
        container.classList.remove('show');
      });

      if (containerElements[index]) {
        containerElements[index].classList.add('show');
      }

      iconEduNav.forEach(icon => {
        icon.classList.remove('active');
      });

      if (iconEduNav[index]) {
        iconEduNav[index].classList.add('active');
      }
    });
  });
});



//polaroids slider
$(document).ready(function(){
  $('.polaroid-wrapper-school').slick({
      slidesToShow: 3,
      slidesToScroll: 1,
      autoplay: true,
      autoplaySpeed: 2000,
      arrows: false,
      draggable: true
  });
});
$(document).ready(function(){
  $('.polaroid-wrapper-friday').slick({
      slidesToShow: 2,
      slidesToScroll: 1,
      autoplay: true,
      autoplaySpeed: 2000,
      arrows: false,
      draggable: true
  });
});



// For .knowledge-state and .knowledge-stats
$(document).on('mouseenter', '.knowledge-state', function() {
  var index = $('.knowledge-state').index(this);
  $('.knowledge-stats').eq(index).addClass('show');

  // Add .not-highlight to all other .knowledge-state elements
  $('.knowledge-state').not(this).addClass('not-highlight');
}).on('mouseleave', '.knowledge-state', function() {
  var index = $('.knowledge-state').index(this);
  $('.knowledge-stats').eq(index).removeClass('show');

  // Remove .not-highlight from all .knowledge-state elements
  $('.knowledge-state').removeClass('not-highlight');
});

// For .attitude-state and .attitude-stats
$(document).on('mouseenter', '.attitude-state', function() {
  var index = $('.attitude-state').index(this);
  $('.attitude-stats').eq(index).addClass('show');

  // Add .not-highlight to all other .attitude-state elements
  $('.attitude-state').not(this).addClass('not-highlight');
}).on('mouseleave', '.attitude-state', function() {
  var index = $('.attitude-state').index(this);
  $('.attitude-stats').eq(index).removeClass('show');

  // Remove .not-highlight from all .attitude-state elements
  $('.attitude-state').removeClass('not-highlight');
});

// education puzzle
const puzzlePieces = document.querySelectorAll('.puzzle-piece');

puzzlePieces.forEach(piece => {
  piece.addEventListener('mouseenter', () => {
    puzzlePieces.forEach(otherPiece => {
      if (otherPiece !== piece) {
        otherPiece.style.opacity = '0.3';
        otherPiece.style.filter = 'blur(0.5px)';
      }
    });
  });

  piece.addEventListener('mouseleave', () => {
    puzzlePieces.forEach(otherPiece => {
      otherPiece.style.opacity = '1';
    });
  });
});


$(document).ready(function(){
  $('.vertical-carousel').slick({
      vertical: false,
      slidesToShow: 1,
      slidesToScroll: 1,
      infinite: true,
      arrows: false,      // Removes arrows
      draggable: true,    // Enables dragging
      autoplay: true,     // Enables autoplay
      autoplaySpeed: 2000, // Sets autoplay speed in milliseconds (e.g., 2000ms = 2 seconds)
      centerMode: true,
      centerPadding: '0',
  });
});

//open evaluation modal
// Wait until the DOM is fully loaded
document.addEventListener("DOMContentLoaded", function() {
  // Select all elements with the class 'clickable-evaluation'
  const clickableElements = document.querySelectorAll('.clickable-evaluation');

  // Iterate over each element
  clickableElements.forEach(element => {
    // Add click event listener to each element
    element.addEventListener('click', function() {
      // Get the target modal id from 'data-target' attribute
      const targetModal = element.getAttribute('data-target');

      // Trigger the Bootstrap modal using the target id
      if (targetModal) {
        const modalElement = document.querySelector(targetModal);
        if (modalElement) {
          const bootstrapModal = new bootstrap.Modal(modalElement);
          bootstrapModal.show();
        }
      }
    });
  });
});

$(document).ready(function() {
  $('.big-carousel').slick({
    autoplay: false,
    dots: false, // No dots indicator
    arrows: true, // Hide navigation arrows
    pauseOnHover: true, // Pause autoplay on hover
    slidesToShow: 1, // Show one slide at a time
    slidesToScroll: 1, // Scroll one slide at a time
    prevArrow: '<button type="button" class="slick-prev"><i class="fas fa-chevron-left"></i></button>',
    nextArrow: '<button type="button" class="slick-next"><i class="fas fa-chevron-right"></i></button>',
  });
});

$(document).ready(function() {
  $('.win-carousel').slick({
    autoplay: true,
    autoplaySpeed: 3000, // 2 seconds
    dots: false, // No dots indicator
    arrows: false, // Hide navigation arrows
    pauseOnHover: true, // Pause autoplay on hover
    slidesToShow: 3, // Show one slide at a time
    slidesToScroll: 1, // Scroll one slide at a time
  });
});
$(document).ready(function() {
  $('.booth-carousel').slick({
    autoplay: true,
    autoplaySpeed: 3000, // 2 seconds
    dots: false, // No dots indicator
    arrows: false, // Hide navigation arrows
    pauseOnHover: true, // Pause autoplay on hover
    slidesToShow: 4, // Show one slide at a time
    slidesToScroll: 4, // Scroll one slide at a time
  });
});








































// ENGINEERING CYCLE ANIMATION
document.addEventListener('DOMContentLoaded', function() {
  // Initially disable scrolling

  // Check if the .engineering class exists on the page
  if (document.querySelector('.engineering')) {
    document.body.style.overflow = 'hidden';

    // Ensure GSAP and ScrollTrigger are loaded
    gsap.registerPlugin(ScrollTrigger);

    // Hide the navigation bar initially
    gsap.set('.engineering-side-nav-wrapper', { autoAlpha: 0 });

    // Initialize Lottie animations and store them in a map
    const lottieAnimationsMap = new Map();

    // For each '.engineering-cycle-wrapper', we need to initialize the Lottie animations
    const wrappers = $('.engineering-cycle-wrapper');
    let totalAnimationsToLoad = 0;
    let animationsLoaded = 0;

    // First, we need to count the total number of Lottie animations to load
    wrappers.each(function (wrapperIndex, wrapperElement) {
      const lottieElements = $(wrapperElement).find('.lottie-animation');
      totalAnimationsToLoad += lottieElements.length;
    });

    // Now, we loop again to load the Lottie animations
    wrappers.each(function (wrapperIndex, wrapperElement) {
      const lottieElements = $(wrapperElement).find('.lottie-animation');
      const lottieAnimations = [];

      lottieElements.each(function (index, element) {
        const anim = lottie.loadAnimation({
          container: element,
          renderer: 'svg',
          loop: false,
          autoplay: false,
          path: 'https://static.igem.wiki/teams/5237/cycle-smaller.json'
        });

        anim.addEventListener('DOMLoaded', function() {
          animationsLoaded++;
          if (animationsLoaded === totalAnimationsToLoad) {
            // All animations are loaded, initialize the GSAP timelines
            initializeTimelines();

            // Enable scrolling
            document.body.style.overflow = 'auto';
          }
        });

        anim.stop(); // Ensure the animation doesn't autoplay
        lottieAnimations.push(anim);
      });

      // Store the lottieAnimations array in the map with the wrapperElement as key
      lottieAnimationsMap.set(wrapperElement, lottieAnimations);
    });

    function initializeTimelines() {
      // For each wrapper
      wrappers.each(function (wrapperIndex, wrapperElement) {
        const lottieAnimations = lottieAnimationsMap.get(wrapperElement);
        const totalSlides = $(wrapperElement).find('.engineering-cycle').length;

        // Create the master timeline
        const masterTimeline = gsap.timeline({
          scrollTrigger: {
            trigger: wrapperElement,
            start: "top top",
            end: () => "+=" + (window.innerHeight * totalSlides * 4.5), // Adjust based on total steps
            scrub: true,
            pin: true,
            anticipatePin: 1,
            // markers: true, // Uncomment to see markers for debugging
          }
        });

        // Define slidesContainer
        const slidesContainer = $(wrapperElement).find('.slides-container');

        // Loop through each slide
        $(wrapperElement).find('.engineering-cycle').each(function (index, slide) {
          const lottieAnimation = lottieAnimations[index];
          const slideDuration = 1; // Adjust the duration for each slide

          const textBlocks = $(slide).find('.text-block');

          // Create a timeline for this slide
          const slideTimeline = gsap.timeline();

          // Lottie animation
          slideTimeline.to({}, {
            duration: slideDuration,
            onUpdate: function () {
              const progress = this.progress();
              const frame = Math.floor(progress * (lottieAnimation.totalFrames - 1));
              lottieAnimation.goToAndStop(frame, true);
            },
            ease: "none"
          });

          // Text blocks animation
          const fadeDuration = 0.05; // Adjust the fade duration here

          textBlocks.each(function(i, elem) {
            const totalBlocks = textBlocks.length;
            const blockDuration = slideDuration / totalBlocks;
            const blockStartTime = i * blockDuration;
            const blockEndTime = (i + 1) * blockDuration;

            if (i === 0) {
              // First text block: make it visible from the start
              gsap.set(elem, { opacity: 1, pointerEvents: 'auto' });
            } else {
              // Fade in at the start of its interval
              slideTimeline.fromTo(elem, {
                opacity: 0,
                pointerEvents: 'none'
              }, {
                opacity: 1,
                duration: fadeDuration,
                ease: "none",
                pointerEvents: 'auto'
              }, blockStartTime);
            }

            if (i !== totalBlocks - 1) {
              // Fade out just before the next block fades in
              slideTimeline.to(elem, {
                opacity: 0,
                duration: fadeDuration,
                ease: "none",
                pointerEvents: 'none'
              }, blockEndTime - fadeDuration);
            }
          });

          // Add the slide timeline to the master timeline
          masterTimeline.add(slideTimeline);

          // Horizontal scroll to next slide (if not the last one)
          if (index < totalSlides - 1) {
            masterTimeline.to(slidesContainer, {
              x: `-=${window.innerWidth}`,
              duration: 0.5,
              ease: "none"
            });
          }
        });

        // Now that the masterTimeline is built, we can get its total duration
        const totalDuration = masterTimeline.duration();

        // Calculate the times to fade in and fade out the navigation bar
        const fadeInTime = totalDuration * 0.001; // 0.1% into the timeline
        const fadeOutTime = totalDuration * 0.999; // 90% into the timeline

        // Fade in the navigation bar
        masterTimeline.to('.engineering-side-nav-wrapper', {
          autoAlpha: 1,
          duration: 0.1,
          ease: "none"
        }, fadeInTime);

        // Fade out the navigation bar
        masterTimeline.to('.engineering-side-nav-wrapper', {
          autoAlpha: 0,
          duration: 0.1,
          ease: "none"
        }, fadeOutTime);
      });
    }

    // Add the event listeners for scroll handling, touch handling, and dragging...
    // (Leaving this part unchanged, as it's not directly related to the loading mechanism)
  }
});

function scrollToSection(event, target) {
  event.preventDefault();

  const overlay = document.getElementById('overlay-engineering');
  overlay.style.visibility = 'visible';
  overlay.style.opacity = '1';

  setTimeout(function () {
    document.querySelector(target).scrollIntoView({
      behavior: 'smooth',
      block: 'start'
    });

    setTimeout(function () {
      overlay.style.opacity = '0';
      overlay.style.visibility = 'hidden';
    }, 500); // Adjust this delay to match your scrolling duration
  }, 250); // Delay before the scrolling starts (adjust as needed)
}
document.addEventListener('DOMContentLoaded', function() {
  const navItems = document.querySelectorAll('.engineering-side-nav-item');

  navItems.forEach(function(navItem) {
    const cycleIcons = navItem.querySelectorAll('.cycle-icon');
    const allCycleIcons = document.querySelectorAll('.cycle-icon');
    const previews = document.querySelectorAll('.wetlab-preview');
    const cycles = document.querySelectorAll('.engineering-cycle-wrapper');
    const placeholder = document.querySelector('.placeholder');

    allCycleIcons.forEach(function(icon, index) {
      icon.addEventListener('mouseenter', function() {
        const preview = previews[index+1];
        preview.classList.add('expanded');
        placeholder.classList.add('expanded');
      });

      icon.addEventListener('mouseleave', function() {
        const preview = previews[index+1];
        preview.classList.remove('expanded');
        placeholder.classList.remove('expanded');
      });
    });

    const observerOptions = {
      root: null,
      rootMargin: '0px',
      threshold: 0.5
    };

    const observer = new IntersectionObserver(function(entries) {
      entries.forEach(function(entry) {
        const index = Array.from(cycles).indexOf(entry.target);
        const correspondingIcon = allCycleIcons[index];

        if (entry.isIntersecting) {
          correspondingIcon.classList.add('active');
        } else {
          correspondingIcon.classList.remove('active');
        }
      });
    }, observerOptions);

    cycles.forEach(function(cycle) {
      observer.observe(cycle);
    });
  });
});

/****************************************/
/* venoboxes contribution file previews */
/****************************************/

new VenoBox({
    selector: '.my-file-previews-summer-school',
});

new VenoBox({
    selector: '.my-file-previews-high-school',
});

new VenoBox({
    selector: '.my-file-previews-survey',
});

new VenoBox({
    selector: '.my-file-previews-primary-school',
});


$(document).ready(function() {
  // Define symbols with image paths
  const symbols = [
      'https://static.igem.wiki/teams/5237/meditation/fred-igem.webp',
      'https://static.igem.wiki/teams/5237/meditation/fred.webp',
      'https://static.igem.wiki/teams/5237/meditation/img-5159.webp',
      'https://static.igem.wiki/teams/5237/meditation/frido-1.webp',
      'https://static.igem.wiki/teams/5237/meditation/brick.webp'
    ];
  
  let isSpinning = false;
  const $button = $('#spinButton');

  function getRandomSymbol() {
      return symbols[Math.floor(Math.random() * symbols.length)];
  }

  function checkWin() {
      const symbol1 = $('#slot1 img').attr('src');
      const symbol2 = $('#slot2 img').attr('src');
      const symbol3 = $('#slot3 img').attr('src');
      return symbol1 === symbol2 && symbol2 === symbol3;
  }

  function updateSlot(slotId, symbolSrc) {
      $(`#${slotId} img`).attr('src', symbolSrc);
  }

  function spin() {
      if (isSpinning) return;
      
      isSpinning = true;
      $button.prop('disabled', true).text('Spinning...');
      $('#winMessage').empty();
      $button.addClass('flash');
      
      $('.slot').addClass('spinning');

      let spins = 0;
      const maxSpins = 20;
      const spinInterval = setInterval(() => {
          updateSlot('slot1', getRandomSymbol());
          updateSlot('slot2', getRandomSymbol());
          updateSlot('slot3', getRandomSymbol());
          
          spins++;
          
          if (spins >= maxSpins) {
              clearInterval(spinInterval);
              $('.slot').removeClass('spinning');
              
              if (checkWin()) {
                  $('#winMessage').html('🎉 Winner! 🎉').addClass('win-message');
              }
              
              isSpinning = false;
              $button.prop('disabled', false).text('Spin!');
              $button.removeClass('flash');
          }
      }, 100);
  }

  $button.on('click', spin);
});
