'use strict';

function loadsimpleSVG(svgName, elementId, callback) {
    const svgFilePath = `https://static.igem.wiki/teams/5237/jsimportsvg/${svgName}.svg`;
    console.log(elementId)
    fetch(svgFilePath)
        .then(response => response.text())
        .then(svg => {
            document.getElementById(elementId).innerHTML = svg;
            if (callback) {
                callback();
            }
        })
        .catch(error => console.error('Error loading SVG:', error));
}

function loadsimpleSVGClass(svgName, elementClass) {
    const svgFilePath = `https://static.igem.wiki/teams/5237/${svgName}.svg`;
    console.log("go class")
    fetch(svgFilePath)
        .then(response => response.text())
        .then(svg => {
            document.querySelectorAll(`.${elementClass}`).forEach(element => {
                element.innerHTML = svg;
            });
        })
        .catch(error => console.error('Error loading SVG:', error));
}
